/*
  ClientUDP.cpp - Ethernet UDP library for Wiring & Arduino,
  based on Client.cpp from Arduino IDE 0016 library.

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

  2009-Jun-25	v1.0, created by Ilya Danilov <arduino@idanilov.ru>
  2009-Jul-12   v1.1, added _sent and open retucn codes by Ilya Danilov <arduino@idanilov.ru>

  
*/

#ifndef ClientUDP_h
#define ClientUDP_h

#include "Print.h"

#define ERR_UDP_NO_ERROR	0
#define ERR_UDP_SOCKET_USED	1
#define ERR_UDP_NO_SOCK_AVAIL	2
#define ERR_UDP_OPEN_FAILED	3


class ClientUDP : public Print {
private:
  static uint16_t _srcport;
  uint8_t  _sock;
  uint8_t  *_ip;
  uint16_t _port;

public:

  uint16_t _sent;

  ClientUDP(uint8_t);
  ClientUDP(uint8_t *, uint16_t);

  uint8_t open(uint16_t = 0);
  uint8_t status();
  virtual void write(uint8_t);
  virtual void write(const uint8_t *, size_t);
  uint16_t read(uint8_t *, uint16_t *, uint8_t *, uint16_t); 
  int available();
  void stop();
  uint8_t opened();
};

#endif
